//TITRE : SOURCE_LUMINEUSE_AUTONOME
//NOM : TREMEAU_MURITH
//Date : 2004

// Bibliothques
#include <90s8535.h>
#include <ssi.h>
#include <delay.h>
#include <stdio.h> 
#include <stdlib.h>

// Etats du graphe
#define Reglage_HTR	0
#define Jour     	1
#define Nuit     	2

// Codes des touches de la carte AT90S8535 SSI
#define INC		0b00011111
#define DEC		0b00101111
#define OK		0b00110111
#define ECHAP		0b00111011
#define SET		0b00111101
#define ENTER		0b00111110

// @I2C HTR
#define	add_HTR		0

// Valeurs de Rglage
#define Seuil_batt1      400      // Valeurs  dfinir
#define Seuil_batt2      800
#define Seuil_lumiere1   400
#define Seuil_lumiere2   800
#define Heure_Jour	 5
#define Heure_Nuit       19

//entres
#define TENSION    6
#define LUMIERE    7

//sortie
#define LAMPE PORTB.0

// I2C Bus functions
#asm
   .equ __i2c_port=0x12
   .equ __sda_bit=3
   .equ __scl_bit=7
#endasm
#include <i2c.h>

// PCF8583 Real Time Clock functions
#include <pcf8583.h>

// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x15
#endasm
#include <lcd.h>

//Read the AD conversion result
unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input;
//Start the AD conversion
ADCSR|=0x40;
//wait for the AD conversion to complete
while ((ADCSR & 0x10)==0);
ADCSR|=0x10;
return ADCW;
}

//VARIABLES GLOBALES
char display_buffer_ligne0[17]; // tampon ligne 0 de l'afficheur
char display_buffer_ligne1[17]; // tampon ligne 1 de l'afficheur


void main(void)
{
// Variables locales 
char *heures, *minutes, *secondes, *secondes_1, *dizieme; //stockage de l'heure
float Valeur_tension_reel;
char Valeur_tension_aff[4];
unsigned int Valeur_tension,Valeur_lumiere; 
unsigned char BP, etat=Reglage_HTR,etat_1 = Jour;  
unsigned char Heure_ou_Date;
unsigned char H_J, mn_mois;
int sec_annee;  

//Port A
PORTA=0x3F;
DDRA=0x00;

//Port B
PORTB = 0x00;
DDRB = 0x1F;  

//ADC Initialisation
ADCSR = 0x81;

//I2C BUS INITIALISATION
i2c_init();

//PCF8583 Real Time Clock initialization
rtc_init(add_HTR,0);

// LCD module initialization
lcd_init(16); 

while (1)      
 { 
  BP = Lire_BP();
  Valeur_lumiere=read_adc(LUMIERE);
  Valeur_tension=read_adc(TENSION);
  rtc_get_time(add_HTR,&heures,&minutes,&secondes,&dizieme);
  Valeur_tension_reel = 5.0*((float)Valeur_tension/1023.0);
  ftoa(Valeur_tension_reel,2,Valeur_tension_aff);
  
 
  switch (etat)
   {
    case Reglage_HTR :  Heure_ou_Date = 0;
    			H_J = 12;
       			mn_mois = 30;
        		sec_annee = 0;
        		regle_HTR(add_HTR,Heure_ou_Date,H_J,mn_mois, sec_annee);
        		if (etat_1 == Nuit)etat = Nuit; 
        	 		else etat = Jour;	 
        	        etat_1 = Reglage_HTR;
        
        break;    
        
        case Jour :     LAMPE=0;        	       
        		if ((etat_1 != etat) || (secondes_1 != secondes))
        		{
        		 
        		 sprintf(display_buffer_ligne0,"Jour Ubatt=%sV",Valeur_tension_aff);
        		 sprintf(display_buffer_ligne1,"%-uh / %-umn / %-us ",heures, minutes, secondes);
        		 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
        	         secondes_1 = secondes;
        	        }
        	        
        		if (BP==SET) etat = Reglage_HTR;
        			else if  ((Valeur_tension>=Seuil_batt2) && (Valeur_lumiere<=Seuil_lumiere1) && (heures>=Heure_Nuit)) etat = Nuit;
        				else etat = Jour;        		
        		etat_1 = Jour;
       
       break;   
       
        case Nuit : // Travail lve	 
 			LAMPE=1; // Eclairer ampoule
 			if ((etat_1 != etat) || (secondes_1 != secondes))
        		  {    			  
        		   sprintf(display_buffer_ligne0,"Nuit Ubatt=%sV",Valeur_tension_aff);
        		   sprintf(display_buffer_ligne1,"%-uh / %-umn / %-us ",heures, minutes, secondes);
        		   Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
        	           secondes_1 = secondes;
        	          }
        	        if (BP==SET) etat = Reglage_HTR;				  
					else if ((heures >=Heure_Jour && heures < Heure_Nuit && Valeur_lumiere>=Seuil_lumiere2)||(Valeur_tension<=Seuil_batt1)) etat = Jour; 
			  			else etat = Nuit;	
      			etat_1 = Nuit;
   	break;
    }  
 }
}
